#!/bin/sh
#2015 goingnuts. Use usr/local/lib/xarchive/wrappers/tar-wrap.sh from XArchive 0.2.8-6
#if you do not have it copy and rename included my-tar-wrap.sh to that location

[[ -x ../../../src/gtkdialog1 ]] && PATH=../../../src:$PATH

#initial temp file
if [ ! "$1" = "" ]; then
	echo ${1} >/tmp/xarchive_name
else
	echo -n > /tmp/xarchive
	echo -n > /tmp/xarchive_name
fi

#selection trackers
echo -n > /tmp/myselect
echo -n > /tmp/chooser_select

#action button various
size=20			#size of buttons
relief="none"	#relief used
ACTBUT='<position>bottom</position>
<height>'$size'</height>
<width>'$size'</width>
<default>'$relief'</default>'


#the functions
echo '
my_fill () {
#TODO: Modify other archive types to fit in fixed header
	case ${1} in
		*.tar|*.tar.gz|*.tgz|*.tar.bz|*.tbz|*.tar.bz2|*.tbz2)
			A=$(/usr/local/lib/xarchive/wrappers/tar-wrap.sh -o $1)
			echo "${A//;/|}" >/tmp/xarchive
			;;
		*)
			echo "Archive not supported" >/tmp/xarchive
			;;
	esac	
}

remove_me () {
	for X in $(cat /tmp/myselect); do
		/usr/local/lib/xarchive/wrappers/tar-wrap.sh -r ${1} ${X} &>/dev/null
	done
	echo -n > /tmp/myselect
}
	
clear_me () {
	echo -n > /tmp/xarchive
	echo -n > /tmp/myselect
}

extract_selected () {
	#use wrapper
	#TODO: choose destination - for now we use present dir
	/usr/local/lib/xarchive/wrappers/tar-wrap.sh -e ${1} $(cat /tmp/myselect)
}

extract_all () {
	#use wrapper
	#TODO: choose destination - for now we use present dir
	/usr/local/lib/xarchive/wrappers/tar-wrap.sh -e ${1}
}

add_me () {
	#guess that archive name and place always present in /tmp/xarchive_name?
	for X in $(cat /tmp/chooser_select); do
		/usr/local/lib/xarchive/wrappers/tar-wrap.sh -a $(cat /tmp/xarchive_name) ${X} &>/dev/null
	done

	echo -n > /tmp/chooser_select
}

select_me () {
	#keep track of seletions - signal emited both at select and deselect
	if [ "$(grep "^${1}$" /tmp/myselect)" = "" ]; then
		echo $1 >> /tmp/myselect
	else
		grep -v "^${1}$" /tmp/myselect > /tmp/myselect1
		cat /tmp/myselect1 > /tmp/myselect
	fi
}

remove_me_chooser () {
	grep -v "^${1}$" /tmp/chooser_select > /tmp/chooser_select1
	cat /tmp/chooser_select1 > /tmp/chooser_select
}

add_me_chooser () {
	echo $1 >> /tmp/chooser_select
}

update_me () {
	echo ${1} >/tmp/xarchive_name
}

' > /tmp/ash_xarchive

export NEW_DIALOG='
<vbox>
	<hbox>
		<text>
			<label>Archive name:</label>
		</text>
		<entry>
			<variable>ARC_NAME</variable>
			<default>somename</default>
		</entry>
		<combobox>
			<height>20</height><width>50</width>
			<variable>ARC_TYPE</variable>
			<default>tar.gz</default>
			<item>tgz</item>
			<item>tar.bz</item>
			<item>tar.bz2</item>
			<item>tbz</item>
			<item>tbz2</item>
			<item>tar</item>
		</combobox>
	</hbox>
	<hbox>
		<text>
			<label>Save in folder:</label>
		</text>
		<entry>
			<variable>SHOW_FOLDER</variable>
			<visible>disabled</visible>
			<input>echo $SAVE_FOLDER</input>
		</entry>
	</hbox>

	<chooser>
		<variable>SAVE_FOLDER</variable>
		<action when="selection-changed">refresh:SHOW_FOLDER</action>
		<default>/</default>
	</chooser>
	<hbox>
		<button>
			<label>Create</label>
			<action>update_me $SHOW_FOLDER/$ARC_NAME.$ARC_TYPE</action>
			<action launchwindow>CHOOSE_DIR</action>
			<action>closewindow:NEW_DIALOG</action>
		</button>
		<button>
			<label>Cancel</label>
			<action>closewindow:NEW_DIALOG</action>
		</button>
	</hbox>
</vbox>
'

export CHOOSE_DIR='
<vbox>
	<entry>
		<variable>ENTRY_CHOOSER</variable>
		<visible>disabled</visible>
		<input>echo $FILE_CHOOSER</input>
	</entry>
	<chooser>
		<variable>FILE_CHOOSER</variable>
		<action when="selection-changed">refresh:ENTRY_CHOOSER</action>
		<default>/</default>
	</chooser>
	<hbox>
		<button>
			<input file stock="gtk-go-down"></input>
   	  	 	<label>Add to list</label>
    		<action>append:ENTRY_CHOOSER,DIR_CHOOSER</action>
    		<action>add_me_chooser $ENTRY_CHOOSER</action>
		</button>
		<button>
			<input file stock="gtk-go-up"></input>
   	  	 	<label>Remove from list</label>
   	  	 	<action>remove_me_chooser $DIR_CHOOSER</action>
   	  	 	<action removeselected>DIR_CHOOSER</action>
   	  	 	<action clear>DIR_CHOOSER</action>
   	  	 	<action>refresh:DIR_CHOOSER</action>
		</button>
	</hbox>
	<hseparator></hseparator>
	<text>
		<label>Files and directories to add:</label>
	</text>
	<list>
		<variable>DIR_CHOOSER</variable>
		<input>cat /tmp/chooser_select</input>
	</list>
	<hbox>
		<button ok>
			<action>add_me</action>
			<action clear>DIR_CHOOSER</action>
			<action clear>CURRENTFILE</action>
			<action>append:MYVAR2,CURRENTFILE</action>
			<action>refresh:CURRENTFILE</action>
			<action>closewindow:CHOOSE_DIR</action>
		</button>
		<button cancel>
			<action>closewindow:CHOOSE_DIR</action>
		</button>
	</hbox>
	<entry>
		<variable>MYVAR2</variable>
		<visible>disabled</visible>
		<input>cat /tmp/xarchive_name</input>
	</entry>
</vbox>
'

export MAIN_DIALOG='
<wtitle>xarchiver</wtitle>
	<vbox>
		<menubar>
			<menu>
				<menuitem>
					<label>gtk-open</label>
					<action>clear_me</action>
					<action type="fileselect">CURRENTFILE</action>
					</menuitem>
				<menuitem>
					<label>gtk-new</label>
					<action launchwindow>NEW_DIALOG</action>
					<action>clear_me</action>
					<action clear>SEL</action>  	
				</menuitem>
				<menuitem>
					<label>gtk-close</label>
					<action>clear_me</action>
					<action clear>CURRENTFILE</action>
					<action clear>SEL</action>
				</menuitem>
				<separator></separator>
				<menuitem>
					<label>gtk-quit</label>
					<action>exit:Quit</action>
				</menuitem>
				<label>File</label>
			</menu>
			<menu>
				<menuitem>
					<input file>/usr/local/share/themes/Default/gtk/icons/gtk-extract.png</input>
					<label>Extract All</label>
					<action>extract_all $CURRENTFILE</action>
				</menuitem>
				<menuitem>
					<input file>/usr/local/share/themes/Default/gtk/icons/gtk-extract.png</input>
					<label>Extract Selected</label>
					<action>extract_selected $CURRENTFILE</action>
				</menuitem>
				<separator></separator>
				<menuitem>
					<label>Add Files</label>
					<input file>/usr/local/share/themes/Default/gtk/icons/gtk-add.png</input>
					<action launchwindow>CHOOSE_DIR</action>
				</menuitem>
				<menuitem>
					<label>Remove Selected</label>
					<input file>/usr/local/share/themes/Default/gtk/icons/gtk-remove.png</input>
					<action>remove_me $CURRENTFILE</action>
					<action>my_fill $CURRENTFILE</action>
					<action>clear:SEL</action>
					<action>refresh:SEL</action>
				</menuitem>
				<label>Actions</label>
			</menu>
		</menubar>
# the action buttons
	
		<hbox>
			<button>
				<input file stock="gtk-open"></input>
				<label>Open</label>
				<tooltip>Open archive file...</tooltip>
				'$ACTBUT'
				<action>clear_me</action>
				<action type="fileselect">CURRENTFILE</action>
			</button>
			<button>
				<input file stock="gtk-new"></input>
				<label>New</label>
				<tooltip>Create new archive file...</tooltip>
				'$ACTBUT'
				<action launchwindow>NEW_DIALOG</action>
				<action>clear_me</action>
				<action clear>SEL</action>  
			</button>
			<button>
				<input file stock="gtk-close"></input>
				<label>Close</label>
				<tooltip>Close archive file...</tooltip>
				'$ACTBUT'
				<action>clear_me</action>
				<action clear>CURRENTFILE</action>
				<action clear>SEL</action>
			</button>
			<vseparator></vseparator>
			<button>
				<input file stock="gtk-quit"></input>
				<label>Quit</label>
				<tooltip>Quit program...</tooltip>
				'$ACTBUT'
				<action>exit:Quit</action>
			</button>		
			<vseparator></vseparator>
			<button>
				<input file>/usr/local/share/themes/Default/gtk/icons/gtk-extract.png</input>
				<label>Extract All</label>
				<tooltip>Extract all files from archive...</tooltip>
				'$ACTBUT'
				<action>extract_all $CURRENTFILE</action>
			</button>	
			<button>
				<input file>/usr/local/share/themes/Default/gtk/icons/gtk-extract.png</input>
				<label>Extract Selected</label>
				<tooltip>Extract selected files...</tooltip>
				'$ACTBUT'
				<action>extract_selected $CURRENTFILE</action>
			</button>	
			<vseparator></vseparator>
			<button>
				<input file>/usr/local/share/themes/Default/gtk/icons/gtk-add.png</input>
				<label>Add Files</label>
				<tooltip>Add files to archive...</tooltip>
				'$ACTBUT'
				<action launchwindow>CHOOSE_DIR</action>
			</button>	
			<button>
				<input file>/usr/local/share/themes/Default/gtk/icons/gtk-remove.png</input>
				<label>Remove Selected</label>
				<tooltip>Remove selected files...</tooltip>
				'$ACTBUT'
				<action>remove_me $CURRENTFILE</action>
				<action>my_fill $CURRENTFILE</action>
				<action>clear:SEL</action>
				<action>refresh:SEL</action>
			</button>	
		</hbox>

# the archive listing
      <frame>
         <table>
         	<label>File|Size|Permissions|User|Group|Date|Time|SymLink</label>
            <variable>SEL</variable>
            <label>Items</label>
            <height>200</height><width>400</width>
            <default>multi</default>
            <input>cat /tmp/xarchive</input>
            <action>select_me $SEL</action>
         </table>
      </frame>
	 <entry>
		<variable>CURRENTFILE</variable>
		<visible>Disabled</visible>
		<input>cat /tmp/xarchive_name</input>		
		<action>my_fill $CURRENTFILE</action>
		<action clear>SEL</action>
		<action>refresh:SEL</action>
		<action>update_me $CURRENTFILE</action>
	</entry>
   </vbox>
</window>'

gtkdialog1 --center --wmclass xarchive --program=MAIN_DIALOG -i /tmp/ash_xarchive

rm -f /tmp/myselect
rm -f /tmp/myselect1
rm -f /tmp/xarchive
rm -f /tmp/xarchive_name
rm -f /tmp/ash_xarchive
rm -f /tmp/chooser_select
